searchNodes=[{"doc":"A cache storage using GenServer as a backend.ExampleThe storage provides two function get/1 and store/2:To store an etag for any path using store/2:ExNoCache.Cache.GenServer.store(&quot;/stair/way/to/heaven&quot;, &quot;etag&quot;) :okThen retrieve it back using get/1:ExNoCache.Cache.GenServer.get(&quot;/stair/way/to/heaven&quot;) &quot;etag&quot;","ref":"ExNoCache.Cache.GenServer.html","title":"ExNoCache.Cache.GenServer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"ExNoCache.Cache.GenServer.html#child_spec/1","title":"ExNoCache.Cache.GenServer.child_spec/1","type":"function"},{"doc":"","ref":"ExNoCache.Cache.GenServer.html#t:etag/0","title":"ExNoCache.Cache.GenServer.etag/0","type":"type"},{"doc":"","ref":"ExNoCache.Cache.GenServer.html#t:path/0","title":"ExNoCache.Cache.GenServer.path/0","type":"type"},{"doc":"","ref":"ExNoCache.Cache.GenServer.html#t:state/0","title":"ExNoCache.Cache.GenServer.state/0","type":"type"},{"doc":"An etag generator.","ref":"ExNoCache.ETag.html","title":"ExNoCache.ETag","type":"module"},{"doc":"Generate ETag.Returns {:ok, binary}.","ref":"ExNoCache.ETag.html#generate/1","title":"ExNoCache.ETag.generate/1","type":"function"},{"doc":"A plug for caching a mid to long term dynamic content.Requires one option::store - The storage module used to store etag per path. See ExNoCache.Cache.GenServer for more detail.Cache mechanismsExNoCache.Plug.Content uses etag for HTTP caching. This means a client should cache the response on the first request and validate the cache on following requests. The cache-control for etag uses &quot;private&quot; mode meaning that the content will be kept in the client browser only.ExNoCache.Plug.Content generate etag using sha256 digest from the response body upon running. It stores the generated etag in ExNoCache.Cache.GenServer as a map of request path and etag.UsageUsing ExNoCache.Plug.Content is very simple, just plug it into any GET request path you want to cache and be done with it.Please be aware that the ExNoCache.Plug.Content works only with GET method. It should be used only with a static path that can generate a dynamic content but the content is rarely change.ExNoCache.Plug.Content should be used as a last resort only when you cannot determined the last updated time of the content. Otherwise use ExNoCache.Plug.LastModified should be better in terms of efficiency since ExNoCache.Plug.Content always allows the request to be processed first before determining the cache-control strategy.ExamplesThis plug can be mounted in a Plug.Builder pipeline as follows:def MyPlug do use Plug.Builder plug ExNoCache.Plug.Content, store: ExNoCache.Cache.GenServer end","ref":"ExNoCache.Plug.Content.html","title":"ExNoCache.Plug.Content","type":"module"},{"doc":"","ref":"ExNoCache.Plug.Content.html#t:options/0","title":"ExNoCache.Plug.Content.options/0","type":"type"},{"doc":"A plug for caching a content using last modify date.Requires one option::updated_at - The Module Function Argument tuple to fetch the last modify date for the content. The function must return a %DateTime{} struct.Cache mechanismsExNoCache.Plug.LastModified uses content last modification datetime to determine whether it should set the last-modified in header response or not.It first look for the client last modify date from the &quot;if-modified-since&quot; in the request headers. Then compare with the content last modify date. If the datetime is equal, the ExNoCache.Plug.LastModified halts the plug and returns the &quot;not modified&quot; immediately. Otherwise request will just go normally and the &quot;last-modified&quot; is added in the response headers.UsageAdd this plug to the pipeline of the endpoint you want to cache using content last update time. Provide the Module Function Argument to get the last updated datetime and it should just work.Please note that the ExNoCache.Plug.LastModified only works with the GET request.ExamplesThis plug can be mounted in a Plug.Builder pipeline as follows:def MyPlug do use Plug.Builder plug ExNoCache.Plug.LastModified, updated_at: {My, :awesome, [&quot;function&quot;]} end","ref":"ExNoCache.Plug.LastModified.html","title":"ExNoCache.Plug.LastModified","type":"module"},{"doc":"","ref":"ExNoCache.Plug.LastModified.html#t:options/0","title":"ExNoCache.Plug.LastModified.options/0","type":"type"},{"doc":"ExNoCache A simple content caching plug that relies on the HTTP &quot;no-cache&quot; strategy (Cache but revalidate).","ref":"readme.html","title":"ExNoCache","type":"extras"},{"doc":"ExNoCache ships with two features:Content validation caching via ExNoCache.Plug.Content.Last modify datetime caching via ExNoCache.Plug.LastModified.","ref":"readme.html#features","title":"ExNoCache - Features","type":"extras"},{"doc":"Before using ExNoCache, you should ask why you need to do this? Is it really necessary?The reason you need to ask yourself first is because there are plenty of better ways than implementing a cache like this yourself. For example, serving a content via CDN or using a Load Balancer static assets serving could reduce your server load a lot.But, if for some reasons, those available caching products cannot serve your business requirements and you're looking for more control over your cache revalidation. The ExNoCache could probably be able to help you.First thing first, the ExNoCache, works on the basis of HTTP no-cache strategy, a.k.a. Cache but revalidate. It won't reduce a network call to your host nor, sometimes, processing the whole request in case of content revalidation base caching.What ExNoCache provides is that it gives you a chance to respond a &quot;304 not modified&quot; header back to client. Which resulting to prevent the whole respond download.With PhoenixExNoCache contains two plugs which can be used like a normal plug.Last modifiedFor example, you have paths that serve a static template. The templates are kept in database and is easy to determine the last modification date.defmodule MyWeb.Router do use MyWeb, :router # snip ... pipeline :template do plug(ExNoCache.Plug.LastModified, updated_at: {My, :awesome, [&quot;function&quot;]}) end scope &quot;/template&quot;, MyWeb do pipe_through([:template]) # GET paths end endThe only option that ExNoCache.Plug.LastModified wants is :updated_at which must be in the mfa() form.The Module function must return the %DateTime{} struct.The plug will call My.awesome(&quot;function&quot;) to determine the last modification date and respond accordingly.ContentIf the last modification datetime is hard to determine or unreliable, you can also use ExNoCache.Plug.Content. It accepts one option, :store, which can be anything that respond to get/1 and store/2. ExNoCache also provide a default gen server in ExNoCache.Cache.GenServer which can be used for a simple use case.Plase note that the ExNoCache.Cache.GenServer is always started.Using the ExNoCache.Plug.Content is simple. Just plug it to your desired path.defmodule MyWeb.Router do use MyWeb, :router # snip ... pipeline :template do plug(ExNoCache.Plug.Content, store: ExNoCache.Cache.GenServer) end scope &quot;/template&quot;, MyWeb do pipe_through([:template]) # GET paths end end","ref":"readme.html#using-exnocache","title":"ExNoCache - Using ExNoCache","type":"extras"},{"doc":"Add :ex_no_cache into your list of dependencies in mix.exs.def deps do [ {:ex_no_cache, &quot;~&gt; 0.1.0&quot;} ] end","ref":"readme.html#installation","title":"ExNoCache - Installation","type":"extras"},{"doc":"Feel free to fork, make changes, and submit a pull request.","ref":"readme.html#contributing","title":"ExNoCache - Contributing","type":"extras"}]